// 
// Copyright (c) 2012-2017, Johannes Wallner
// 
// This file (MinisatWrapper.h) is part of cegartix
// 
// cegartix is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// cegartix is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with cegartix; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//

#ifndef MINISATWRAPPER_H_
#define MINISATWRAPPER_H_

#include <core/Solver.h>
#include "AbstractSolverWrapper.h"

//#define l_True  (Minisat::lbool((uint8_t)0))
//#define l_False (Minisat::lbool((uint8_t)1))
//#define l_Undef (Minisat::lbool((uint8_t)2))

using namespace Minisat; //fixes issue/workaround with lbool... requires this namespace.

class MinisatWrapper: public AbstractSolverWrapper
{
public:
	MinisatWrapper();
	bool addClause(AbstractLit p);
	bool addClause(AbstractLit p, AbstractLit q);
	bool addClause(AbstractLit p, AbstractLit q, AbstractLit r);
	bool addClause_(std::vector<AbstractLit>& ps);
	int newVar();
	bool solve();
	bool solveLimited(std::vector<AbstractLit>& assumps);
	std::vector<int> model();
	bool simplify();
	Minisat::Solver solver;
	static Minisat::Lit getLit(AbstractLit lit);
	// for disabling incremental solving:
	std::vector<std::vector<AbstractLit> > clausesToProcess;
	std::vector<int> resModel;
	int maxVar;
};

#endif /* MINISATWRAPPER_H_ */
